#!/bin/sh
#
# The "help" action.
#
# Copyright 2023-2024 Andrew Wood
#
# License GPLv3+: GNU GPL version 3 or later; see `docs/COPYING'.
#

uactHelp () {
	uactLoadExtensions
	printf "%s: %s %s\n" "Usage" "${PACKAGE_NAME}" "[OPTION]... ACTION [ARGUMENT]..."
	printf "%s\n\n" "Perform administrative actions."
	printf "%s\n" "Options:"
	printf "  -n, --non-interactive  %s\n" "switch off terminal interaction"
	printf "  -i, --interactive      %s\n" "enable interaction without terminal"
	printf "  -v, --verbose          %s\n" "show the real commands being run"
	printf "  -vv, --debug           %s\n" "show debug messages"
	printf "  -q, --quiet            %s\n" "discard errors"
	printf "  -qq, --very-quiet      %s\n" "discard output as well as errors"
	printf "  -j, --json             %s\n" "produce output in JSON format"
	printf "  -o, --output FILE      %s\n" "redirect output to append to FILE"
	printf "  -t, --tee FILE         %s\n" "append a copy of raw output to FILE"
	printf "  -e, --error FILE       %s\n" "redirect errors to append to FILE"
	printf "  -h, --help             %s\n" "show this help and exit"
	printf "  -V, --version          %s\n" "show version information and exit"
	printf "\n%s\n" "Actions:"
	printf "  package-install        %s\n" "install one or more packages"
	printf "  package-upgrade        %s\n" "upgrade one or more packages"
	printf "  package-downgrade      %s\n" "downgrade one or more packages"
	printf "  package-remove         %s\n" "remove one or more packages"
	printf "  package-reinstall      %s\n" "reinstall one or more packages"
	printf "  package-info           %s\n" "show package information"
	printf "  package-files          %s\n" "list the files owned by a package"
	printf "  package-owning-file    %s\n" "list which package owns a file"
	printf "  package-cache-update   %s\n" "update package manager cache"
	printf "  package-cache-clean    %s\n" "clean package manager caches"
	printf "  package-upgrade-list   %s\n" "list available package upgrades"
	printf "  package-upgrade-all    %s\n" "upgrade all packages"
	printf "  package-list-installed %s\n" "show all installed packages"
	printf "  service-start          %s\n" "start a service"
	printf "  service-stop           %s\n" "stop a service"
	printf "  service-restart        %s\n" "stop and start a service"
	printf "  service-try-restart    %s\n" "restart service if running"
	printf "  service-reload         %s\n" "reload service configuration"
	printf "  service-enable         %s\n" "enable a service"
	printf "  service-disable        %s\n" "disable a service"
	printf "  service-mask           %s\n" "mask a service"
	printf "  service-unmask         %s\n" "unmask a service"
	printf "  service-is-known       %s\n" "check a service exists"
	printf "  service-is-running     %s\n" "check a service is running"
	printf "  service-is-enabled     %s\n" "check a service is enabled"
	printf "  service-is-masked      %s\n" "check a service is masked"
	printf "  service-list-all       %s\n" "list known services"
	printf "  system-info            %s\n" "show key system information"
	printf "  listening-ports        %s\n" "list open TCP and UDP ports"
	printf "%s\n" "${extensionList}" | awk -F "\t" '/^./ {printf "  %-22s %s\n", $1, $4}'
	printf "\n%s <%s>.\n" "Please report any bugs to" "${PACKAGE_BUGREPORT}"
}
